Summary: FISh programming language (Functional = Imperative + Shape)
Name: fish
Version: 1.6
Release: 2
Packager: Franklin Chen <Franklin.Chen@cs.cmu.edu>
Source: http://www-staff.socs.uts.EDU.AU:8080/~cbj/cgi-bin/FISh.source-1.6.tar.gz
Url: http://www-staff.socs.uts.edu.au/~cbj/FISh
Copyright: C. Barry Jay
Group: Development/Languages

%description
FISh is a new array programming language that combines (and extends)
the EXPRESSIVE POWER of functional programming with the EFFICIENT
EXECUTION of imperative, or procedural, programming by performing
STATIC SHAPE ANALYSIS on all programs. This shape computation reduces
higher-order functional programs to simple imperative forms, i.e. F -
Sh = I. Conversely, FISh works best when functions are constructed from
imperative procedures and shape functions, as recommended by the slogan
that gives the language its name.

FISh execution speeds on typical array problems are several times faster
than other higher-order, polymorphic languages.

%prep

%setup -n FISh.source-1.6

%build
make BINDIR=/usr/bin
cat > fish.header << 'EOF'
#!/bin/sh
FISH_LIB_DIR=/usr/lib/fish
export FISH_LIB_DIR
PATH=$FISH_LIB_DIR/bin:$PATH
EOF

%install
mkdir -p /usr/lib/fish /usr/lib/fish/bin /usr/lib/fish/include /usr/lib/fish/lib
make SHAPE=/usr/lib/fish install
sed 's^/homes/shape^/usr/lib/fish^g' fcc > /usr/lib/fish/bin/fcc
chmod a+rx /usr/lib/fish/bin/fcc
cp standard_prelude.fsh /usr/lib/fish

for i in fish fish.byte fish.prof
do
	cp $i /usr/lib/fish/bin
	(cat fish.header; echo 'exec '$i' ${1+"$@"}') > /usr/bin/$i
	chmod a+rx /usr/bin/$i
done

%files
%doc README INSTALL
/usr/bin/fish
/usr/bin/fish.byte
/usr/bin/fish.prof
/usr/lib/fish
